# How to contribute to Kopano Core

If you have found an issue and want to report an issue, either reach out to us
in our [forum](https://forum.kopano.io), or, if you have a subscription, open
up a [support case](https://kopano.com/support/).

To provide changesets,

- Clone the repository from https://stash.kopano.io/ or
https://github.com/Kopano-mirror/kopano-core .
- Commit and [sign your work](
https://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/tree/Documentation/process/submitting-patches.rst?h=v4.10-rc4#n416)
(```git commit -s```).
- Upload commits to a git store of your choosing, or export the series as a
patchset using [git format-patch](https://git-scm.com/docs/git-format-patch).
- Send the patch(es) or git link to
[contributing@kopano.io](mailto:contributing@kopano.io) and we will consider
the submission.

## Additional notes

- Please only work on one issue per commit.
- Before implementing a new feature, get in contact with us, so we can
determine the impact.
